/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.35 from the
 * contents of UnixCrypt_XS.xs. Do not edit this file, edit UnixCrypt_XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "UnixCrypt_XS.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#ifndef bytes_from_utf8

/* 5.6.0 has UTF-8 scalars, but lacks the utility bytes_from_utf8() */

static U8 *
bytes_from_utf8(U8 *orig, STRLEN *len_p, bool *is_utf8_p)
{
	STRLEN orig_len = *len_p;
	U8 *orig_end = orig + orig_len;
	STRLEN new_len = orig_len;
	U8 *new;
	U8 *p, *q;
	if(!*is_utf8_p)
		return orig;
	for(p = orig; p != orig_end; ) {
		U8 fb = *p++, sb;
		if(fb <= 0x7f)
			continue;
		if(p == orig_end || !(fb >= 0xc2 && fb <= 0xc3))
			return orig;
		sb = *p++;
		if(!(sb >= 0x80 && sb <= 0xbf))
			return orig;
		new_len--;
	}
	if(new_len == orig_len) {
		*is_utf8_p = 0;
		return orig;
	}
	Newz(0, new, new_len+1, U8);
	for(p = orig, q = new; p != orig_end; ) {
		U8 fb = *p++;
		*q++ = fb <= 0x7f ? fb : ((fb & 0x03) << 6) | (*p++ & 0x3f);
	}
	*q = 0;
	*len_p = new_len;
	*is_utf8_p = 0;
	return new;
}

#endif /* !bytes_from_utf8 */

#include <./fcrypt/fcrypt.h>

static void
sv_to_octets(U8 **octets_p, STRLEN *len_p, bool *must_free_p, SV *sv)
{
  U8 *in_str = SvPV(sv, *len_p);
  bool is_utf8 = !!SvUTF8(sv);
  *octets_p = bytes_from_utf8(in_str, len_p, &is_utf8);
  if(is_utf8)
    croak("input must contain only octets");
  *must_free_p = *octets_p != in_str;
}

static void
sv_to_cblock(des_cblock block, SV *in_block)
{
  U8 *in_octets;
  STRLEN in_len;
  bool must_free;
  sv_to_octets(&in_octets, &in_len, &must_free, in_block);
  if(in_len != 8)
    croak("data block must be eight octets long");
  memcpy(block, in_octets, 8);
  if(must_free)
    Safefree(in_octets);
}

#line 86 "UnixCrypt_XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 230 "UnixCrypt_XS.c"

XS_EUPXS(XS_Crypt__UnixCrypt_XS_crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "password, salt");
    {
	SV *	password = ST(0)
;
	SV *	salt = ST(1)
;
	char *	RETVAL;
	dXSTARG;
#line 83 "UnixCrypt_XS.xs"
    STRLEN password_len, salt_len;
    U8 *password_octets, *salt_octets;
    bool password_tofree, salt_tofree;
    char outbuf[21];
    sv_to_octets(&password_octets, &password_len, &password_tofree, password);
    sv_to_octets(&salt_octets, &salt_len, &salt_tofree, salt);
    des_fcrypt((char *)password_octets, password_len,
	(char *)salt_octets, salt_len, outbuf);
    if(password_tofree)
      Safefree(password_octets);
    if(salt_tofree)
      Safefree(salt_octets);
    RETVAL = outbuf;
#line 259 "UnixCrypt_XS.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__UnixCrypt_XS_crypt_rounds); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_crypt_rounds)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "password, nrounds, saltnum, in_block");
    {
	SV *	password = ST(0)
;
	unsigned long	nrounds = (unsigned long)SvUV(ST(1))
;
	unsigned long	saltnum = (unsigned long)SvUV(ST(2))
;
	SV *	in_block = ST(3)
;
	SV *	RETVAL;
#line 106 "UnixCrypt_XS.xs"
    STRLEN password_len;
    U8 *password_octets;
    bool password_tofree;
    des_cblock key, block;
    sv_to_octets(&password_octets, &password_len, &password_tofree, password);
    sv_to_cblock(block, in_block);
    trad_password_to_key(key, (char *)password_octets, password_len);
    if(password_tofree)
      Safefree(password_octets);
    crypt_rounds(key, nrounds, saltnum, block);
    RETVAL = newSVpvn(block, 8);
#line 294 "UnixCrypt_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__UnixCrypt_XS_fold_password); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_fold_password)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "password");
    {
	SV *	password = ST(0)
;
	SV *	RETVAL;
#line 124 "UnixCrypt_XS.xs"
    STRLEN password_len;
    U8 *password_octets;
    bool password_tofree;
    des_cblock key;
    int i;
    sv_to_octets(&password_octets, &password_len, &password_tofree, password);
    ext_password_to_key(key, (char *)password_octets, password_len);
    if(password_tofree)
      Safefree(password_octets);
    for(i=0; i<8; i++)
      key[i] = (key[i] & 0xfe) >> 1;
    RETVAL = newSVpvn(key, 8);
#line 325 "UnixCrypt_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__UnixCrypt_XS_base64_to_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_base64_to_block)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "base64");
    {
	SV *	base64 = ST(0)
;
	SV *	RETVAL;
#line 143 "UnixCrypt_XS.xs"
    STRLEN base64_len;
    U8 *base64_octets;
    bool base64_tofree;
    des_cblock block;
    sv_to_octets(&base64_octets, &base64_len, &base64_tofree, base64);
    if(base64_len != 11)
      croak("data block in base 64 must be eleven characters long");
    base64_to_block(block, (char *)base64_octets);
    if(base64_tofree)
      Safefree(base64_octets);
    RETVAL = newSVpvn(block, 8);
#line 355 "UnixCrypt_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__UnixCrypt_XS_block_to_base64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_block_to_base64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in_block");
    {
	SV *	in_block = ST(0)
;
	char *	RETVAL;
	dXSTARG;
#line 161 "UnixCrypt_XS.xs"
    des_cblock block;
    char base64[12];
    sv_to_cblock(block, in_block);
    block_to_base64(block, base64);
    RETVAL = base64;
#line 380 "UnixCrypt_XS.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__UnixCrypt_XS_base64_to_int24); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_base64_to_int24)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "base64");
    {
	SV *	base64 = ST(0)
;
	unsigned long	RETVAL;
	dXSTARG;
#line 173 "UnixCrypt_XS.xs"
    STRLEN base64_len;
    U8 *base64_octets;
    bool base64_tofree;
    sv_to_octets(&base64_octets, &base64_len, &base64_tofree, base64);
    if(base64_len != 4)
      croak("24-bit integer in base 64 must be four characters long");
    RETVAL = base64_to_int24((char *)base64_octets);
    if(base64_tofree)
      Safefree(base64_octets);
#line 408 "UnixCrypt_XS.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__UnixCrypt_XS_int24_to_base64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_int24_to_base64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "val");
    {
	unsigned long	val = (unsigned long)SvUV(ST(0))
;
	char *	RETVAL;
	dXSTARG;
#line 189 "UnixCrypt_XS.xs"
    char base64[5];
    int24_to_base64(val, base64);
    RETVAL = base64;
#line 430 "UnixCrypt_XS.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__UnixCrypt_XS_base64_to_int12); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_base64_to_int12)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "base64");
    {
	SV *	base64 = ST(0)
;
	unsigned long	RETVAL;
	dXSTARG;
#line 199 "UnixCrypt_XS.xs"
    STRLEN base64_len;
    U8 *base64_octets;
    bool base64_tofree;
    sv_to_octets(&base64_octets, &base64_len, &base64_tofree, base64);
    if(base64_len != 2)
      croak("12-bit integer in base 64 must be two characters long");
    RETVAL = base64_to_int12((char *)base64_octets);
    if(base64_tofree)
      Safefree(base64_octets);
#line 458 "UnixCrypt_XS.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__UnixCrypt_XS_int12_to_base64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__UnixCrypt_XS_int12_to_base64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "val");
    {
	unsigned long	val = (unsigned long)SvUV(ST(0))
;
	char *	RETVAL;
	dXSTARG;
#line 215 "UnixCrypt_XS.xs"
    char base64[3];
    int12_to_base64(val, base64);
    RETVAL = base64;
#line 480 "UnixCrypt_XS.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Crypt__UnixCrypt_XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__UnixCrypt_XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Crypt::UnixCrypt_XS::crypt", XS_Crypt__UnixCrypt_XS_crypt);
        newXS_deffile("Crypt::UnixCrypt_XS::crypt_rounds", XS_Crypt__UnixCrypt_XS_crypt_rounds);
        newXS_deffile("Crypt::UnixCrypt_XS::fold_password", XS_Crypt__UnixCrypt_XS_fold_password);
        newXS_deffile("Crypt::UnixCrypt_XS::base64_to_block", XS_Crypt__UnixCrypt_XS_base64_to_block);
        newXS_deffile("Crypt::UnixCrypt_XS::block_to_base64", XS_Crypt__UnixCrypt_XS_block_to_base64);
        newXS_deffile("Crypt::UnixCrypt_XS::base64_to_int24", XS_Crypt__UnixCrypt_XS_base64_to_int24);
        newXS_deffile("Crypt::UnixCrypt_XS::int24_to_base64", XS_Crypt__UnixCrypt_XS_int24_to_base64);
        newXS_deffile("Crypt::UnixCrypt_XS::base64_to_int12", XS_Crypt__UnixCrypt_XS_base64_to_int12);
        newXS_deffile("Crypt::UnixCrypt_XS::int12_to_base64", XS_Crypt__UnixCrypt_XS_int12_to_base64);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

